
# OdinOnDemand

OdinOnDemand (OOD) adds several forms of multimedia to Valheim that allow 
players to watch YouTube and direct video files on an in-game screen. Create your own cinema!
The mod also contains a boombox that can either play direct audio files, or SoundCloud links (with availability) - 
and all of this is multiplayer compatible and seemingly relatively low-impact.   

YouTube now works natively! Be sure to wipe configs.

[<img alt="Preview Video" width="256px" src="https://i.imgur.com/0BaY28I.jpg" />](https://www.youtube.com/watch?v=hePW1dueKjE)



## Features

- Cinema screens
   - Flatscreen TV, Table TV, Old TV, Laptop
   - Can play YouTube, Remote and Local files
- Audio Players
   - Boombox
- Multiplayer functionality
- Audio Control <sub>(Client Side)</sub>
- Forward Tracking <sub>(Client Side)</sub>

These first releases can be considered betas as it has not been extensively tested. Please report any issues on
the GitHub tracker.

## Installation

Installation of the plugin is fairly straightforward, just install into Bepinex/plugins or use r2modman. It must be installed on both server and client.

See NodeJS Server Installation for backup/selfhosted YouTube functionality.

## Use
In game, place down a cinema screen or boombox. Every player costs 2 bronze currently. Interact with it to open the GUI.

For cinema screens, you must have
either a direct link to a remote or local video file of a 
[compatible codec](https://docs.unity3d.com/2020.1/Documentation/Manual/VideoSources-FileCompatibility.html)
or use a youtube/youtu.be link. YouTube is now enabled by default. You can change between the built in YouTube library vs the self-hosted 
NodeJS server for grabbing YouTube links in the config. The NodeJS server may be more consistent 
or higher quality. See NodeJS setup for more. 

For boomboxes, you must have a direct link to a remote or local audio file of a 
[compatible codec](https://support.unity.com/hc/en-us/articles/206484803-What-are-the-supported-Audio-formats-in-Unity-)
or use a soundcloud.com link. Through testing I've noticed some SoundCloud songs are 
unavailable. I think it depends on the artist and how they upload/license their art. 

Local files are not synced over multiplayer.

Put the link into the input field and click set to set a file. Control playback
with play, pause, and stop. Press "Pickup" to remove the mediaplayer and refund materials.
Control individual player's volume with "+" and "-" and toggle mute with the "M" button on the overflow menu.
">" to track forward. 

In the mod settings you can control master volume. This will affect every screen/boombox.

All set file/play/pause/stop commands should be synced for multiplayer through RPC events. 
Volume and tracking are client sided. Tracking will de-sync. 
Screens do not currently check for sync or update to currently playing videos when connecting/loading new mediaplayers.

## NodeJS Server Installation

[Tutorial Video](https://www.youtube.com/watch?v=9_vs8MItO38)

[Github Instructions](https://github.com/modestimpala/OdinOnDemand)

## Screenshots 
![Mod Screenshot](https://i.imgur.com/QL6gvwc.jpg)
![Mod Screenshot](https://i.imgur.com/Y88KuWV.jpg)
![Mod Screenshot](https://i.imgur.com/wTmD6Cc.jpeg)
<sub>[Build by DanAugust](https://www.valheimians.com/build/small-simple-cabin-pre-plains/) Last picture is with backlight setting turned off.</sub>

## Acknowledgements

 - [SoundCloudExplode](https://github.com/jerry08/SoundCloudExplode) | [YouTubeExplode](https://github.com/Tyrrrz/YoutubeExplode) | [youtube-exec-dl](https://www.npmjs.com/package/youtube-dl-exec) | [nodejs](https://nodejs.org/en/) | [yt-dlp](https://github.com/yt-dlp/yt-dlp)
 - Inspired by [Raft Cinema Mod](https://www.raftmodding.com/mods/cinema-mod)


